#include <stdio.h>
#include <stdlib.h>
#include <sys/stat.h>
#include <unistd.h>
#include <fcntl.h>
#include "vlock.h"

static unsigned char lines, columns;
static void *screen_buf = NULL;
static int vcs;

void clear_screen(void)
{
	struct stat s_buf;
	int i;
	char path[16];

	if (fstat(0, &s_buf)==-1) {
		return;
	}
	if (!S_ISCHR(s_buf.st_mode)) {
		return;
	}
	if ((s_buf.st_rdev / 256) != 4) {
		return;
	}
	i = s_buf.st_rdev % 256;
	sprintf(path, "/dev/vcsa%d", i);
	vcs = open(path, O_RDWR);
	if (vcs<0) {
		return;
	}
	if (read(vcs, &columns, 1)!=1) {
		close(vcs);
		return;
	}
	if (read(vcs, &lines, 1)!=1) {
		close(vcs);
		return;
	}
	screen_buf = malloc(2*lines*columns+2);
	if (!screen_buf) {
		close(vcs);
		return;
	}
	if (read(vcs, screen_buf, 2*lines*columns+2) != 2*lines*columns+2) {
		free(screen_buf);
		screen_buf=NULL;
		close(vcs);
		return;
	}
	write(1, "\33[H\33[J", 6);	/* There's no need to use ncurses */
	fflush(stdout);
}

void restore_screen(void)
{
	if (screen_buf) {
		lseek(vcs, 0, SEEK_SET);
		write(vcs, &columns, 1);
		write(vcs, &lines, 1);
		write(vcs, screen_buf, 2*lines*columns+2);
		close(vcs);
	}
}
